//+------------------------------------------------------------------+
//|                                                       T3 RVI.mq4 |
//|                                       Original Code by FX Sniper |
//|                                  Copyright  2007, Forex-TSD.com |
//|                                              Written by Linuxser |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 Blue
#property  indicator_color2  Red
#property  indicator_level1  80
#property  indicator_level2  20
#property  indicator_levelcolor Gray
#property  indicator_levelstyle 2
//----
extern int ExtRVIPeriod=10;
extern int T3_Period = 5;
extern double b = 0.618;
extern int Style  = 0; 

//----
double e1, e2, e3, e4, e5, e6;
double e1a, e2a, e3a, e4a, e5a, e6a;
double c1, c2, c3, c4;
double c1a, c2a, c3a, c4a;
double n, w1, w2, b2, b3;
double na, w1a, w2a, b2a, b3a;
double RVI[];
double RVI_Signal[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators setting
    SetIndexBuffer(0, RVI);
    SetIndexBuffer(1, RVI_Signal);

//----
    SetIndexStyle(0, DRAW_LINE);
    SetIndexStyle(1, DRAW_LINE);

    
//----        
    IndicatorShortName("RVI T3("+ExtRVIPeriod+" T3 "+T3_Period+ ")");
    SetIndexLabel(0, "RVI");     
    SetIndexLabel(1, "Signal");
   
//---- variable reset
    b2 = b*b;
    b3 = b2*b;
    c1 = -b3;
    c2 = (3*(b2 + b3));
    c3 = -3*(2*b2 + b + b3);
    c4 = (1 + 3*b + b3 + 3*b2);
    n = T3_Period;
    
    b2a = b*b;
    b3a = b2a*b;
    c1a = -b3a;
    c2a = (3*(b2a + b3a));
    c3a = -3*(2*b2a + b + b3a);
    c4a = (1 + 3*b + b3a + 3*b2a);
    na = T3_Period;
//----
    if(n < 1) 
        n = 1;
    
    w1 = 2 / (n + 1);
    w2 = 1 - w1;
    
        na = 1;
    na = 1 + 0.5*(na - 1);
    w1a = 2 / (na + 1);
    w2a = 1 - w1a;     
//----
    return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars = IndicatorCounted();
//---- check for possible errors
   if(counted_bars < 0) 
       return(-1);
//---- last counted bar will be recounted
   if(counted_bars > 0) 
       counted_bars--;
   limit = Bars - counted_bars;  
//---- indicator calculation
   for(int i = Bars - 1; i >= 0; i--)
     {   
       RVI[i] = iRVI(NULL,0,ExtRVIPeriod,MODE_MAIN,i);       
       e1 = w1*RVI[i] + w2*e1;
       e2 = w1*e1 + w2*e2;
       e3 = w1*e2 + w2*e3;
       e4 = w1*e3 + w2*e4;
       e5 = w1*e4 + w2*e5;
       e6 = w1*e5 + w2*e6;    
       RVI[i] = c1*e6 + c2*e5 + c3*e4 + c4*e3;    
       
       RVI_Signal[i] = iRVI(NULL,0,ExtRVIPeriod,MODE_SIGNAL,i);  
       e1a = w1a*RVI_Signal[i] + w2a*e1a;
       e2a = w1a*e1a + w2a*e2a;
       e3a = w1a*e2a + w2a*e3a;
       e4a = w1a*e3a + w2a*e4a;
       e5a = w1a*e4a + w2a*e5a;
       e6a = w1a*e5a + w2a*e6a;       
       RVI_Signal[i] = c1a*e6a + c2a*e5a + c3a*e4a + c4a*e3a;      
       } 
             
//----
   return(0);
  }
//+------------------------------------------------------------------+